//Script_DestroyAbandonedVehicles.cs
//Destroys abandoned vehicles

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Respawn Delay (mins)","Vehicle Respawn","Vehicles::BlowupTime","int 1 60","Server_VehicleRespawn",5);
   RTB_registerPref("Minimum Distance","Vehicle Respawn","Vehicles::BlowupDistance","int 1 999999","Server_VehicleRespawn",100);
}
else
{
   $Vehicles::BlowupTime = 5;
   $Vehicles::BlowupDistance = 100;
}

function Vehicle::respawnAndBlow(%obj)
{
	if(!isObject(%obj.getMountNodeObject(0).client))
	{
		%brick = %obj.spawnBrick;
		%obj.finalExplosion();
		%brick.schedule(100,"spawnVehicle");
	}
}

function checkClientVehicle(%client)
{
	%player = %client.player;
	if(!isObject(%player))
		return;

	%vehicle = %player.getObjectMount();	
	if(%vehicle.getClassName() !$= "Player" && %vehicle.getClassName() !$= "AIPlayer" && %vehicle.dataBlock.getName() !$= "SkiVehicle")
	        %vehicle.checkForExplode(%vehicle);
}

function Vehicle::checkForExplode(%obj)
{
	if(%obj.dataBlock.getName() $= "SkiVehicle")
		return;

	if(isObject(%obj.getMountNodeObject(0).client))
	{
		if(isEventPending(%obj.explodeSchedule))
			cancel(%obj.explodeSchedule);
		return;
	}
	else
	{
		%vPos = %obj.getPosition();
		%spawn = %obj.spawnBrick.getPosition();
		if(vectorDist(%vPos,%spawn) > $Vehicles::BlowupDistance)
		{
			if(isEventPending(%obj.explodeSchedule))
				cancel(%obj.explodeSchedule);

			%obj.explodeSchedule = %obj.schedule(($Vehicles::BlowupTime*60)*1000,"respawnAndBlow");
		}
	}
}

package VehicleRespawnPackage
{
	function Vehicle::onDriverLeave(%obj,%player)
	{
		Parent::onDriverLeave(%obj,%player);
		if(isObject(%obj))
			%obj.checkForExplode();
	}

	function Vehicle::oncollision(%this,%obj,%col,%a,%b)
	{ 
		parent::oncollision(%this,%obj,%col,%a,%b);
		%this.schedule(10,"checkForExplode",%obj);
	}

	function serverCmdPrevSeat(%client)
	{
		Parent::serverCmdPrevSeat(%client);
		schedule(10,0,"checkClientVehicle",%client);
	}

	function serverCmdNextSeat(%client)
	{
		Parent::serverCmdNextSeat(%client);
		schedule(10,0,"checkClientVehicle",%client);
	}
};
activatePackage(VehicleRespawnPackage);